import { windowOrGlobal } from './';

(base => {
  window = base || window;
  // $FlowFixMe: Why are we using localStorage at all?
  if (!window.localStorage) window.localStorage = {};
})(windowOrGlobal);

// clean up time

const NATIVE_LOGGERS = {};

const getModuleKey = module => `${module.app.name}:${module.namespace}`;

export const getLogger = module => {
  const key = getModuleKey(module);
  return NATIVE_LOGGERS[key];
};

export const initialiseLogger = (module, logNamespace) => {
  const key = getModuleKey(module);
  if (!NATIVE_LOGGERS[key]) {
    // eslint-disable-next-line global-require
    NATIVE_LOGGERS[key] = require('bows')(`🔥 ${logNamespace.toUpperCase()}`);
  }
};

export default class Log {
  static createLogger(namespace) {
    // eslint-disable-next-line global-require
    return require('bows')(namespace);
  }

  static setLevel(booleanOrDebugString) {
    window.localStorage.debug = booleanOrDebugString;
    window.localStorage.debugColors = !!booleanOrDebugString;
  }
}